<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCallAheadNumber ArrayType
 * @subpackage Arrays
 */
class ArrayOfCallAheadNumber extends AbstractStructArrayBase
{
    /**
     * The CallAheadNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CallAheadNumber[]
     */
    public $CallAheadNumber;
    /**
     * Constructor method for ArrayOfCallAheadNumber
     * @uses ArrayOfCallAheadNumber::setCallAheadNumber()
     * @param \StructType\CallAheadNumber[] $callAheadNumber
     */
    public function __construct(array $callAheadNumber = array())
    {
        $this
            ->setCallAheadNumber($callAheadNumber);
    }
    /**
     * Get CallAheadNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CallAheadNumber[]|null
     */
    public function getCallAheadNumber()
    {
        return isset($this->CallAheadNumber) ? $this->CallAheadNumber : null;
    }
    /**
     * Set CallAheadNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CallAheadNumber[] $callAheadNumber
     * @return \ArrayType\ArrayOfCallAheadNumber
     */
    public function setCallAheadNumber(array $callAheadNumber = array())
    {
        foreach ($callAheadNumber as $arrayOfCallAheadNumberCallAheadNumberItem) {
            // validation for constraint: itemType
            if (!$arrayOfCallAheadNumberCallAheadNumberItem instanceof \StructType\CallAheadNumber) {
                throw new \InvalidArgumentException(sprintf('The CallAheadNumber property can only contain items of \StructType\CallAheadNumber, "%s" given', is_object($arrayOfCallAheadNumberCallAheadNumberItem) ? get_class($arrayOfCallAheadNumberCallAheadNumberItem) : gettype($arrayOfCallAheadNumberCallAheadNumberItem)), __LINE__);
            }
        }
        if (is_null($callAheadNumber) || (is_array($callAheadNumber) && empty($callAheadNumber))) {
            unset($this->CallAheadNumber);
        } else {
            $this->CallAheadNumber = $callAheadNumber;
        }
        return $this;
    }
    /**
     * Add item to CallAheadNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\CallAheadNumber $item
     * @return \ArrayType\ArrayOfCallAheadNumber
     */
    public function addToCallAheadNumber(\StructType\CallAheadNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CallAheadNumber) {
            throw new \InvalidArgumentException(sprintf('The CallAheadNumber property can only contain items of \StructType\CallAheadNumber, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CallAheadNumber[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CallAheadNumber|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CallAheadNumber|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CallAheadNumber|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CallAheadNumber|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CallAheadNumber|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CallAheadNumber
     */
    public function getAttributeName()
    {
        return 'CallAheadNumber';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCallAheadNumber
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
