<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCreateDeliveryResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfCreateDeliveryResult extends AbstractStructArrayBase
{
    /**
     * The CreateDeliveryResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CreateDeliveryResult[]
     */
    public $CreateDeliveryResult;
    /**
     * Constructor method for ArrayOfCreateDeliveryResult
     * @uses ArrayOfCreateDeliveryResult::setCreateDeliveryResult()
     * @param \StructType\CreateDeliveryResult[] $createDeliveryResult
     */
    public function __construct(array $createDeliveryResult = array())
    {
        $this
            ->setCreateDeliveryResult($createDeliveryResult);
    }
    /**
     * Get CreateDeliveryResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CreateDeliveryResult[]|null
     */
    public function getCreateDeliveryResult()
    {
        return isset($this->CreateDeliveryResult) ? $this->CreateDeliveryResult : null;
    }
    /**
     * Set CreateDeliveryResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CreateDeliveryResult[] $createDeliveryResult
     * @return \ArrayType\ArrayOfCreateDeliveryResult
     */
    public function setCreateDeliveryResult(array $createDeliveryResult = array())
    {
        foreach ($createDeliveryResult as $arrayOfCreateDeliveryResultCreateDeliveryResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfCreateDeliveryResultCreateDeliveryResultItem instanceof \StructType\CreateDeliveryResult) {
                throw new \InvalidArgumentException(sprintf('The CreateDeliveryResult property can only contain items of \StructType\CreateDeliveryResult, "%s" given', is_object($arrayOfCreateDeliveryResultCreateDeliveryResultItem) ? get_class($arrayOfCreateDeliveryResultCreateDeliveryResultItem) : gettype($arrayOfCreateDeliveryResultCreateDeliveryResultItem)), __LINE__);
            }
        }
        if (is_null($createDeliveryResult) || (is_array($createDeliveryResult) && empty($createDeliveryResult))) {
            unset($this->CreateDeliveryResult);
        } else {
            $this->CreateDeliveryResult = $createDeliveryResult;
        }
        return $this;
    }
    /**
     * Add item to CreateDeliveryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateDeliveryResult $item
     * @return \ArrayType\ArrayOfCreateDeliveryResult
     */
    public function addToCreateDeliveryResult(\StructType\CreateDeliveryResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateDeliveryResult) {
            throw new \InvalidArgumentException(sprintf('The CreateDeliveryResult property can only contain items of \StructType\CreateDeliveryResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CreateDeliveryResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateDeliveryResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateDeliveryResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateDeliveryResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateDeliveryResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateDeliveryResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateDeliveryResult
     */
    public function getAttributeName()
    {
        return 'CreateDeliveryResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCreateDeliveryResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
