<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryLineItemUpdate ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeliveryLineItemUpdate extends AbstractStructArrayBase
{
    /**
     * The DeliveryLineItemUpdate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeliveryLineItemUpdate[]
     */
    public $DeliveryLineItemUpdate;
    /**
     * Constructor method for ArrayOfDeliveryLineItemUpdate
     * @uses ArrayOfDeliveryLineItemUpdate::setDeliveryLineItemUpdate()
     * @param \StructType\DeliveryLineItemUpdate[] $deliveryLineItemUpdate
     */
    public function __construct(array $deliveryLineItemUpdate = array())
    {
        $this
            ->setDeliveryLineItemUpdate($deliveryLineItemUpdate);
    }
    /**
     * Get DeliveryLineItemUpdate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeliveryLineItemUpdate[]|null
     */
    public function getDeliveryLineItemUpdate()
    {
        return isset($this->DeliveryLineItemUpdate) ? $this->DeliveryLineItemUpdate : null;
    }
    /**
     * Set DeliveryLineItemUpdate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryLineItemUpdate[] $deliveryLineItemUpdate
     * @return \ArrayType\ArrayOfDeliveryLineItemUpdate
     */
    public function setDeliveryLineItemUpdate(array $deliveryLineItemUpdate = array())
    {
        foreach ($deliveryLineItemUpdate as $arrayOfDeliveryLineItemUpdateDeliveryLineItemUpdateItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryLineItemUpdateDeliveryLineItemUpdateItem instanceof \StructType\DeliveryLineItemUpdate) {
                throw new \InvalidArgumentException(sprintf('The DeliveryLineItemUpdate property can only contain items of \StructType\DeliveryLineItemUpdate, "%s" given', is_object($arrayOfDeliveryLineItemUpdateDeliveryLineItemUpdateItem) ? get_class($arrayOfDeliveryLineItemUpdateDeliveryLineItemUpdateItem) : gettype($arrayOfDeliveryLineItemUpdateDeliveryLineItemUpdateItem)), __LINE__);
            }
        }
        if (is_null($deliveryLineItemUpdate) || (is_array($deliveryLineItemUpdate) && empty($deliveryLineItemUpdate))) {
            unset($this->DeliveryLineItemUpdate);
        } else {
            $this->DeliveryLineItemUpdate = $deliveryLineItemUpdate;
        }
        return $this;
    }
    /**
     * Add item to DeliveryLineItemUpdate value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryLineItemUpdate $item
     * @return \ArrayType\ArrayOfDeliveryLineItemUpdate
     */
    public function addToDeliveryLineItemUpdate(\StructType\DeliveryLineItemUpdate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryLineItemUpdate) {
            throw new \InvalidArgumentException(sprintf('The DeliveryLineItemUpdate property can only contain items of \StructType\DeliveryLineItemUpdate, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeliveryLineItemUpdate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeliveryLineItemUpdate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeliveryLineItemUpdate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeliveryLineItemUpdate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeliveryLineItemUpdate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeliveryLineItemUpdate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryLineItemUpdate
     */
    public function getAttributeName()
    {
        return 'DeliveryLineItemUpdate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDeliveryLineItemUpdate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
