<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeliveryStop ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeliveryStop extends AbstractStructArrayBase
{
    /**
     * The DeliveryStop
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeliveryStop[]
     */
    public $DeliveryStop;
    /**
     * Constructor method for ArrayOfDeliveryStop
     * @uses ArrayOfDeliveryStop::setDeliveryStop()
     * @param \StructType\DeliveryStop[] $deliveryStop
     */
    public function __construct(array $deliveryStop = array())
    {
        $this
            ->setDeliveryStop($deliveryStop);
    }
    /**
     * Get DeliveryStop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeliveryStop[]|null
     */
    public function getDeliveryStop()
    {
        return isset($this->DeliveryStop) ? $this->DeliveryStop : null;
    }
    /**
     * Set DeliveryStop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryStop[] $deliveryStop
     * @return \ArrayType\ArrayOfDeliveryStop
     */
    public function setDeliveryStop(array $deliveryStop = array())
    {
        foreach ($deliveryStop as $arrayOfDeliveryStopDeliveryStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeliveryStopDeliveryStopItem instanceof \StructType\DeliveryStop) {
                throw new \InvalidArgumentException(sprintf('The DeliveryStop property can only contain items of \StructType\DeliveryStop, "%s" given', is_object($arrayOfDeliveryStopDeliveryStopItem) ? get_class($arrayOfDeliveryStopDeliveryStopItem) : gettype($arrayOfDeliveryStopDeliveryStopItem)), __LINE__);
            }
        }
        if (is_null($deliveryStop) || (is_array($deliveryStop) && empty($deliveryStop))) {
            unset($this->DeliveryStop);
        } else {
            $this->DeliveryStop = $deliveryStop;
        }
        return $this;
    }
    /**
     * Add item to DeliveryStop value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryStop $item
     * @return \ArrayType\ArrayOfDeliveryStop
     */
    public function addToDeliveryStop(\StructType\DeliveryStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryStop) {
            throw new \InvalidArgumentException(sprintf('The DeliveryStop property can only contain items of \StructType\DeliveryStop, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeliveryStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeliveryStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeliveryStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeliveryStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeliveryStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeliveryStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeliveryStop
     */
    public function getAttributeName()
    {
        return 'DeliveryStop';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDeliveryStop
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
