<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistanceForDriver ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistanceForDriver extends AbstractStructArrayBase
{
    /**
     * The DistanceForDriver
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistanceForDriver[]
     */
    public $DistanceForDriver;
    /**
     * Constructor method for ArrayOfDistanceForDriver
     * @uses ArrayOfDistanceForDriver::setDistanceForDriver()
     * @param \StructType\DistanceForDriver[] $distanceForDriver
     */
    public function __construct(array $distanceForDriver = array())
    {
        $this
            ->setDistanceForDriver($distanceForDriver);
    }
    /**
     * Get DistanceForDriver value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistanceForDriver[]|null
     */
    public function getDistanceForDriver()
    {
        return isset($this->DistanceForDriver) ? $this->DistanceForDriver : null;
    }
    /**
     * Set DistanceForDriver value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceForDriver[] $distanceForDriver
     * @return \ArrayType\ArrayOfDistanceForDriver
     */
    public function setDistanceForDriver(array $distanceForDriver = array())
    {
        foreach ($distanceForDriver as $arrayOfDistanceForDriverDistanceForDriverItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistanceForDriverDistanceForDriverItem instanceof \StructType\DistanceForDriver) {
                throw new \InvalidArgumentException(sprintf('The DistanceForDriver property can only contain items of \StructType\DistanceForDriver, "%s" given', is_object($arrayOfDistanceForDriverDistanceForDriverItem) ? get_class($arrayOfDistanceForDriverDistanceForDriverItem) : gettype($arrayOfDistanceForDriverDistanceForDriverItem)), __LINE__);
            }
        }
        if (is_null($distanceForDriver) || (is_array($distanceForDriver) && empty($distanceForDriver))) {
            unset($this->DistanceForDriver);
        } else {
            $this->DistanceForDriver = $distanceForDriver;
        }
        return $this;
    }
    /**
     * Add item to DistanceForDriver value
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceForDriver $item
     * @return \ArrayType\ArrayOfDistanceForDriver
     */
    public function addToDistanceForDriver(\StructType\DistanceForDriver $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistanceForDriver) {
            throw new \InvalidArgumentException(sprintf('The DistanceForDriver property can only contain items of \StructType\DistanceForDriver, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DistanceForDriver[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistanceForDriver|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistanceForDriver|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistanceForDriver|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistanceForDriver|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistanceForDriver|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistanceForDriver
     */
    public function getAttributeName()
    {
        return 'DistanceForDriver';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDistanceForDriver
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
