<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicle ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicle extends AbstractStructArrayBase
{
    /**
     * The vehicle
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Vehicle[]
     */
    public $vehicle;
    /**
     * Constructor method for ArrayOfVehicle
     * @uses ArrayOfVehicle::setVehicle()
     * @param \StructType\Vehicle[] $vehicle
     */
    public function __construct(array $vehicle = array())
    {
        $this
            ->setVehicle($vehicle);
    }
    /**
     * Get vehicle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Vehicle[]|null
     */
    public function getVehicle()
    {
        return isset($this->vehicle) ? $this->vehicle : null;
    }
    /**
     * Set vehicle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Vehicle[] $vehicle
     * @return \ArrayType\ArrayOfVehicle
     */
    public function setVehicle(array $vehicle = array())
    {
        foreach ($vehicle as $arrayOfVehicleVehicleItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleVehicleItem instanceof \StructType\Vehicle) {
                throw new \InvalidArgumentException(sprintf('The vehicle property can only contain items of \StructType\Vehicle, "%s" given', is_object($arrayOfVehicleVehicleItem) ? get_class($arrayOfVehicleVehicleItem) : gettype($arrayOfVehicleVehicleItem)), __LINE__);
            }
        }
        if (is_null($vehicle) || (is_array($vehicle) && empty($vehicle))) {
            unset($this->vehicle);
        } else {
            $this->vehicle = $vehicle;
        }
        return $this;
    }
    /**
     * Add item to vehicle value
     * @throws \InvalidArgumentException
     * @param \StructType\Vehicle $item
     * @return \ArrayType\ArrayOfVehicle
     */
    public function addToVehicle(\StructType\Vehicle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Vehicle) {
            throw new \InvalidArgumentException(sprintf('The vehicle property can only contain items of \StructType\Vehicle, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->vehicle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Vehicle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Vehicle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Vehicle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Vehicle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Vehicle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string vehicle
     */
    public function getAttributeName()
    {
        return 'vehicle';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
