<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleAtContact ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleAtContact extends AbstractStructArrayBase
{
    /**
     * The VehicleAtContact
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleAtContact[]
     */
    public $VehicleAtContact;
    /**
     * Constructor method for ArrayOfVehicleAtContact
     * @uses ArrayOfVehicleAtContact::setVehicleAtContact()
     * @param \StructType\VehicleAtContact[] $vehicleAtContact
     */
    public function __construct(array $vehicleAtContact = array())
    {
        $this
            ->setVehicleAtContact($vehicleAtContact);
    }
    /**
     * Get VehicleAtContact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleAtContact[]|null
     */
    public function getVehicleAtContact()
    {
        return isset($this->VehicleAtContact) ? $this->VehicleAtContact : null;
    }
    /**
     * Set VehicleAtContact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleAtContact[] $vehicleAtContact
     * @return \ArrayType\ArrayOfVehicleAtContact
     */
    public function setVehicleAtContact(array $vehicleAtContact = array())
    {
        foreach ($vehicleAtContact as $arrayOfVehicleAtContactVehicleAtContactItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleAtContactVehicleAtContactItem instanceof \StructType\VehicleAtContact) {
                throw new \InvalidArgumentException(sprintf('The VehicleAtContact property can only contain items of \StructType\VehicleAtContact, "%s" given', is_object($arrayOfVehicleAtContactVehicleAtContactItem) ? get_class($arrayOfVehicleAtContactVehicleAtContactItem) : gettype($arrayOfVehicleAtContactVehicleAtContactItem)), __LINE__);
            }
        }
        if (is_null($vehicleAtContact) || (is_array($vehicleAtContact) && empty($vehicleAtContact))) {
            unset($this->VehicleAtContact);
        } else {
            $this->VehicleAtContact = $vehicleAtContact;
        }
        return $this;
    }
    /**
     * Add item to VehicleAtContact value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleAtContact $item
     * @return \ArrayType\ArrayOfVehicleAtContact
     */
    public function addToVehicleAtContact(\StructType\VehicleAtContact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleAtContact) {
            throw new \InvalidArgumentException(sprintf('The VehicleAtContact property can only contain items of \StructType\VehicleAtContact, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleAtContact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleAtContact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleAtContact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleAtContact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleAtContact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleAtContact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleAtContact
     */
    public function getAttributeName()
    {
        return 'VehicleAtContact';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleAtContact
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
