<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleHistoryV2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleHistoryV2 extends AbstractStructArrayBase
{
    /**
     * The VehicleHistoryV2
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleHistoryV2[]
     */
    public $VehicleHistoryV2;
    /**
     * Constructor method for ArrayOfVehicleHistoryV2
     * @uses ArrayOfVehicleHistoryV2::setVehicleHistoryV2()
     * @param \StructType\VehicleHistoryV2[] $vehicleHistoryV2
     */
    public function __construct(array $vehicleHistoryV2 = array())
    {
        $this
            ->setVehicleHistoryV2($vehicleHistoryV2);
    }
    /**
     * Get VehicleHistoryV2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleHistoryV2[]|null
     */
    public function getVehicleHistoryV2()
    {
        return isset($this->VehicleHistoryV2) ? $this->VehicleHistoryV2 : null;
    }
    /**
     * Set VehicleHistoryV2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleHistoryV2[] $vehicleHistoryV2
     * @return \ArrayType\ArrayOfVehicleHistoryV2
     */
    public function setVehicleHistoryV2(array $vehicleHistoryV2 = array())
    {
        foreach ($vehicleHistoryV2 as $arrayOfVehicleHistoryV2VehicleHistoryV2Item) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleHistoryV2VehicleHistoryV2Item instanceof \StructType\VehicleHistoryV2) {
                throw new \InvalidArgumentException(sprintf('The VehicleHistoryV2 property can only contain items of \StructType\VehicleHistoryV2, "%s" given', is_object($arrayOfVehicleHistoryV2VehicleHistoryV2Item) ? get_class($arrayOfVehicleHistoryV2VehicleHistoryV2Item) : gettype($arrayOfVehicleHistoryV2VehicleHistoryV2Item)), __LINE__);
            }
        }
        if (is_null($vehicleHistoryV2) || (is_array($vehicleHistoryV2) && empty($vehicleHistoryV2))) {
            unset($this->VehicleHistoryV2);
        } else {
            $this->VehicleHistoryV2 = $vehicleHistoryV2;
        }
        return $this;
    }
    /**
     * Add item to VehicleHistoryV2 value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleHistoryV2 $item
     * @return \ArrayType\ArrayOfVehicleHistoryV2
     */
    public function addToVehicleHistoryV2(\StructType\VehicleHistoryV2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleHistoryV2) {
            throw new \InvalidArgumentException(sprintf('The VehicleHistoryV2 property can only contain items of \StructType\VehicleHistoryV2, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleHistoryV2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleHistoryV2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleHistoryV2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleHistoryV2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleHistoryV2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleHistoryV2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleHistoryV2
     */
    public function getAttributeName()
    {
        return 'VehicleHistoryV2';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleHistoryV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
