<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleOdometerReading ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleOdometerReading extends AbstractStructArrayBase
{
    /**
     * The VehicleOdometerReading
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleOdometerReading[]
     */
    public $VehicleOdometerReading;
    /**
     * Constructor method for ArrayOfVehicleOdometerReading
     * @uses ArrayOfVehicleOdometerReading::setVehicleOdometerReading()
     * @param \StructType\VehicleOdometerReading[] $vehicleOdometerReading
     */
    public function __construct(array $vehicleOdometerReading = array())
    {
        $this
            ->setVehicleOdometerReading($vehicleOdometerReading);
    }
    /**
     * Get VehicleOdometerReading value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleOdometerReading[]|null
     */
    public function getVehicleOdometerReading()
    {
        return isset($this->VehicleOdometerReading) ? $this->VehicleOdometerReading : null;
    }
    /**
     * Set VehicleOdometerReading value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleOdometerReading[] $vehicleOdometerReading
     * @return \ArrayType\ArrayOfVehicleOdometerReading
     */
    public function setVehicleOdometerReading(array $vehicleOdometerReading = array())
    {
        foreach ($vehicleOdometerReading as $arrayOfVehicleOdometerReadingVehicleOdometerReadingItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleOdometerReadingVehicleOdometerReadingItem instanceof \StructType\VehicleOdometerReading) {
                throw new \InvalidArgumentException(sprintf('The VehicleOdometerReading property can only contain items of \StructType\VehicleOdometerReading, "%s" given', is_object($arrayOfVehicleOdometerReadingVehicleOdometerReadingItem) ? get_class($arrayOfVehicleOdometerReadingVehicleOdometerReadingItem) : gettype($arrayOfVehicleOdometerReadingVehicleOdometerReadingItem)), __LINE__);
            }
        }
        if (is_null($vehicleOdometerReading) || (is_array($vehicleOdometerReading) && empty($vehicleOdometerReading))) {
            unset($this->VehicleOdometerReading);
        } else {
            $this->VehicleOdometerReading = $vehicleOdometerReading;
        }
        return $this;
    }
    /**
     * Add item to VehicleOdometerReading value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleOdometerReading $item
     * @return \ArrayType\ArrayOfVehicleOdometerReading
     */
    public function addToVehicleOdometerReading(\StructType\VehicleOdometerReading $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleOdometerReading) {
            throw new \InvalidArgumentException(sprintf('The VehicleOdometerReading property can only contain items of \StructType\VehicleOdometerReading, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleOdometerReading[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleOdometerReading|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleOdometerReading|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleOdometerReading|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleOdometerReading|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleOdometerReading|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleOdometerReading
     */
    public function getAttributeName()
    {
        return 'VehicleOdometerReading';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleOdometerReading
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
