<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleUpdateResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleUpdateResult extends AbstractStructArrayBase
{
    /**
     * The VehicleUpdateResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleUpdateResult[]
     */
    public $VehicleUpdateResult;
    /**
     * Constructor method for ArrayOfVehicleUpdateResult
     * @uses ArrayOfVehicleUpdateResult::setVehicleUpdateResult()
     * @param \StructType\VehicleUpdateResult[] $vehicleUpdateResult
     */
    public function __construct(array $vehicleUpdateResult = array())
    {
        $this
            ->setVehicleUpdateResult($vehicleUpdateResult);
    }
    /**
     * Get VehicleUpdateResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleUpdateResult[]|null
     */
    public function getVehicleUpdateResult()
    {
        return isset($this->VehicleUpdateResult) ? $this->VehicleUpdateResult : null;
    }
    /**
     * Set VehicleUpdateResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleUpdateResult[] $vehicleUpdateResult
     * @return \ArrayType\ArrayOfVehicleUpdateResult
     */
    public function setVehicleUpdateResult(array $vehicleUpdateResult = array())
    {
        foreach ($vehicleUpdateResult as $arrayOfVehicleUpdateResultVehicleUpdateResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleUpdateResultVehicleUpdateResultItem instanceof \StructType\VehicleUpdateResult) {
                throw new \InvalidArgumentException(sprintf('The VehicleUpdateResult property can only contain items of \StructType\VehicleUpdateResult, "%s" given', is_object($arrayOfVehicleUpdateResultVehicleUpdateResultItem) ? get_class($arrayOfVehicleUpdateResultVehicleUpdateResultItem) : gettype($arrayOfVehicleUpdateResultVehicleUpdateResultItem)), __LINE__);
            }
        }
        if (is_null($vehicleUpdateResult) || (is_array($vehicleUpdateResult) && empty($vehicleUpdateResult))) {
            unset($this->VehicleUpdateResult);
        } else {
            $this->VehicleUpdateResult = $vehicleUpdateResult;
        }
        return $this;
    }
    /**
     * Add item to VehicleUpdateResult value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleUpdateResult $item
     * @return \ArrayType\ArrayOfVehicleUpdateResult
     */
    public function addToVehicleUpdateResult(\StructType\VehicleUpdateResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleUpdateResult) {
            throw new \InvalidArgumentException(sprintf('The VehicleUpdateResult property can only contain items of \StructType\VehicleUpdateResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleUpdateResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleUpdateResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleUpdateResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleUpdateResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleUpdateResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleUpdateResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleUpdateResult
     */
    public function getAttributeName()
    {
        return 'VehicleUpdateResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleUpdateResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
