<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Ping' => '\\StructType\\Ping',
            'PingResponse' => '\\StructType\\PingResponse',
            'getJobCollection' => '\\StructType\\GetJobCollection',
            'searchCriteria' => '\\StructType\\SearchCriteria',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'ArrayOfStatusOptions' => '\\ArrayType\\ArrayOfStatusOptions',
            'getJobCollectionResponse' => '\\StructType\\GetJobCollectionResponse',
            'ArrayOfJob' => '\\ArrayType\\ArrayOfJob',
            'job' => '\\StructType\\Job',
            'getJobCollectionV2' => '\\StructType\\GetJobCollectionV2',
            'getJobCollectionV2Response' => '\\StructType\\GetJobCollectionV2Response',
            'ArrayOfJobV2' => '\\ArrayType\\ArrayOfJobV2',
            'JobV2' => '\\StructType\\JobV2',
            'ArrayOfLineItem' => '\\ArrayType\\ArrayOfLineItem',
            'LineItem' => '\\StructType\\LineItem',
            'getCurrentDrivers' => '\\StructType\\GetCurrentDrivers',
            'getCurrentDriversResponse' => '\\StructType\\GetCurrentDriversResponse',
            'ArrayOfDriver' => '\\ArrayType\\ArrayOfDriver',
            'driver' => '\\StructType\\Driver',
            'addLocation' => '\\StructType\\AddLocation',
            'Location' => '\\StructType\\Location',
            'addLocationResponse' => '\\StructType\\AddLocationResponse',
            'addLocationV2' => '\\StructType\\AddLocationV2',
            'LocationV2' => '\\StructType\\LocationV2',
            'OpenElementElement' => '\\StructType\\OpenElementElement',
            'ArrayOfXmlElement' => '\\ArrayType\\ArrayOfXmlElement',
            'XmlElement' => '\\StructType\\XmlElement',
            'addLocationV2Response' => '\\StructType\\AddLocationV2Response',
            'deleteLocation' => '\\StructType\\DeleteLocation',
            'deleteLocationResponse' => '\\StructType\\DeleteLocationResponse',
            'getNearestVehicle' => '\\StructType\\GetNearestVehicle',
            'getNearestVehicleResponse' => '\\StructType\\GetNearestVehicleResponse',
            'ArrayOfVehicle' => '\\ArrayType\\ArrayOfVehicle',
            'vehicle' => '\\StructType\\Vehicle',
            'getNearestVehicleV2' => '\\StructType\\GetNearestVehicleV2',
            'getNearestVehicleV2Response' => '\\StructType\\GetNearestVehicleV2Response',
            'ArrayOfVehicleV2' => '\\ArrayType\\ArrayOfVehicleV2',
            'VehicleV2' => '\\StructType\\VehicleV2',
            'getVehicleUpdate' => '\\StructType\\GetVehicleUpdate',
            'getVehicleUpdateResponse' => '\\StructType\\GetVehicleUpdateResponse',
            'getVehicleUpdateV2' => '\\StructType\\GetVehicleUpdateV2',
            'getVehicleUpdateV2Response' => '\\StructType\\GetVehicleUpdateV2Response',
            'createRoute' => '\\StructType\\CreateRoute',
            'collection' => '\\StructType\\Collection',
            'createRouteResponse' => '\\StructType\\CreateRouteResponse',
            'createJob' => '\\StructType\\CreateJob',
            'createJobResponse' => '\\StructType\\CreateJobResponse',
            'CreateAllocatedRoute' => '\\StructType\\CreateAllocatedRoute',
            'AllocatedRoute' => '\\StructType\\AllocatedRoute',
            'ArrayOfDelivery' => '\\ArrayType\\ArrayOfDelivery',
            'Delivery' => '\\StructType\\Delivery',
            'ArrayOfCallAheadNumber' => '\\ArrayType\\ArrayOfCallAheadNumber',
            'CallAheadNumber' => '\\StructType\\CallAheadNumber',
            'DateRange' => '\\StructType\\DateRange',
            'CreateAllocatedRouteResponse' => '\\StructType\\CreateAllocatedRouteResponse',
            'CreateAllocatedRouteResult' => '\\StructType\\CreateAllocatedRouteResult',
            'ArrayOfCreateDeliveryResult' => '\\ArrayType\\ArrayOfCreateDeliveryResult',
            'CreateDeliveryResult' => '\\StructType\\CreateDeliveryResult',
            'CreateAllocatedRouteV2' => '\\StructType\\CreateAllocatedRouteV2',
            'AllocatedRouteV2' => '\\StructType\\AllocatedRouteV2',
            'CreateAllocatedRouteV2Response' => '\\StructType\\CreateAllocatedRouteV2Response',
            'CreateAllocatedRouteV2ForVehicle' => '\\StructType\\CreateAllocatedRouteV2ForVehicle',
            'AllocatedVehicleRoute' => '\\StructType\\AllocatedVehicleRoute',
            'CreateAllocatedRouteV2ForVehicleResponse' => '\\StructType\\CreateAllocatedRouteV2ForVehicleResponse',
            'GetHistory' => '\\StructType\\GetHistory',
            'ArrayOfEventType' => '\\ArrayType\\ArrayOfEventType',
            'EventType' => '\\StructType\\EventType',
            'GetHistoryResponse' => '\\StructType\\GetHistoryResponse',
            'ArrayOfVehicleHistory' => '\\ArrayType\\ArrayOfVehicleHistory',
            'VehicleHistory' => '\\StructType\\VehicleHistory',
            'ArrayOfVehicleEvent' => '\\ArrayType\\ArrayOfVehicleEvent',
            'VehicleEvent' => '\\StructType\\VehicleEvent',
            'ArrayOfAdditionalInformation' => '\\ArrayType\\ArrayOfAdditionalInformation',
            'AdditionalInformation' => '\\StructType\\AdditionalInformation',
            'GetHistoryV2' => '\\StructType\\GetHistoryV2',
            'GetHistoryV2Response' => '\\StructType\\GetHistoryV2Response',
            'ArrayOfVehicleHistoryV2' => '\\ArrayType\\ArrayOfVehicleHistoryV2',
            'VehicleHistoryV2' => '\\StructType\\VehicleHistoryV2',
            'GetVehiclesAtContact' => '\\StructType\\GetVehiclesAtContact',
            'GetVehiclesAtContactResponse' => '\\StructType\\GetVehiclesAtContactResponse',
            'ArrayOfVehicleAtContact' => '\\ArrayType\\ArrayOfVehicleAtContact',
            'VehicleAtContact' => '\\StructType\\VehicleAtContact',
            'GetVersion' => '\\StructType\\GetVersion',
            'GetVersionResponse' => '\\StructType\\GetVersionResponse',
            'AddVehicleActualOdometerReadings' => '\\StructType\\AddVehicleActualOdometerReadings',
            'ArrayOfVehicleOdometerReading' => '\\ArrayType\\ArrayOfVehicleOdometerReading',
            'VehicleOdometerReading' => '\\StructType\\VehicleOdometerReading',
            'AddVehicleActualOdometerReadingsResponse' => '\\StructType\\AddVehicleActualOdometerReadingsResponse',
            'ArrayOfVehicleUpdateResult' => '\\ArrayType\\ArrayOfVehicleUpdateResult',
            'VehicleUpdateResult' => '\\StructType\\VehicleUpdateResult',
            'GetVehicleCalculatedCurrentOdometerReadings' => '\\StructType\\GetVehicleCalculatedCurrentOdometerReadings',
            'GetVehicleCalculatedCurrentOdometerReadingsResponse' => '\\StructType\\GetVehicleCalculatedCurrentOdometerReadingsResponse',
            'SetVehicleNextServiceInformation' => '\\StructType\\SetVehicleNextServiceInformation',
            'ArrayOfNextServiceInformation' => '\\ArrayType\\ArrayOfNextServiceInformation',
            'NextServiceInformation' => '\\StructType\\NextServiceInformation',
            'SetVehicleNextServiceInformationResponse' => '\\StructType\\SetVehicleNextServiceInformationResponse',
            'SetGroupForVehicles' => '\\StructType\\SetGroupForVehicles',
            'SetGroupForVehiclesResponse' => '\\StructType\\SetGroupForVehiclesResponse',
            'GetDeliveryStatusChange' => '\\StructType\\GetDeliveryStatusChange',
            'GetDeliveryStatusChangeResponse' => '\\StructType\\GetDeliveryStatusChangeResponse',
            'ArrayOfDeliveryStop' => '\\ArrayType\\ArrayOfDeliveryStop',
            'DeliveryStop' => '\\StructType\\DeliveryStop',
            'DeleteRoute' => '\\StructType\\DeleteRoute',
            'DeleteRouteResponse' => '\\StructType\\DeleteRouteResponse',
            'ExpireRouteResult' => '\\StructType\\ExpireRouteResult',
            'GetDistanceTravelled' => '\\StructType\\GetDistanceTravelled',
            'GetDistanceTravelledResponse' => '\\StructType\\GetDistanceTravelledResponse',
            'ArrayOfDistanceForDriver' => '\\ArrayType\\ArrayOfDistanceForDriver',
            'DistanceForDriver' => '\\StructType\\DistanceForDriver',
            'UpdateDeliveryStart' => '\\StructType\\UpdateDeliveryStart',
            'UpdateDeliveryStartResponse' => '\\StructType\\UpdateDeliveryStartResponse',
            'UpdateDeliveryEnd' => '\\StructType\\UpdateDeliveryEnd',
            'UpdateDeliveryEndResponse' => '\\StructType\\UpdateDeliveryEndResponse',
            'UpdateDeliveryCompletionDetails' => '\\StructType\\UpdateDeliveryCompletionDetails',
            'UpdateDeliveryCompletionDetailsResponse' => '\\StructType\\UpdateDeliveryCompletionDetailsResponse',
            'UpdateDeliveryCompletionDetailsV2' => '\\StructType\\UpdateDeliveryCompletionDetailsV2',
            'StopCompletionDetails' => '\\StructType\\StopCompletionDetails',
            'UpdateDeliveryCompletionDetailsV2Response' => '\\StructType\\UpdateDeliveryCompletionDetailsV2Response',
            'UpdateDeliveryLineItemQuantities' => '\\StructType\\UpdateDeliveryLineItemQuantities',
            'ArrayOfDeliveryLineItemUpdate' => '\\ArrayType\\ArrayOfDeliveryLineItemUpdate',
            'DeliveryLineItemUpdate' => '\\StructType\\DeliveryLineItemUpdate',
            'UpdateDeliveryLineItemQuantitiesResponse' => '\\StructType\\UpdateDeliveryLineItemQuantitiesResponse',
            'LoadVehicleChecks' => '\\StructType\\LoadVehicleChecks',
            'VehicleCheck' => '\\StructType\\VehicleCheck',
            'ArrayOfVehicleCheckDetail' => '\\ArrayType\\ArrayOfVehicleCheckDetail',
            'VehicleCheckDetail' => '\\StructType\\VehicleCheckDetail',
            'LoadVehicleChecksResponse' => '\\StructType\\LoadVehicleChecksResponse',
            'CreateLateArrivalAlertForRouteStop' => '\\StructType\\CreateLateArrivalAlertForRouteStop',
            'StopLateArrivalAlert' => '\\StructType\\StopLateArrivalAlert',
            'WebServiceStopAlert' => '\\StructType\\WebServiceStopAlert',
            'WebServiceAlert' => '\\StructType\\WebServiceAlert',
            'CreateLateArrivalAlertForRouteStopResponse' => '\\StructType\\CreateLateArrivalAlertForRouteStopResponse',
            'CreateAlertsResult' => '\\StructType\\CreateAlertsResult',
            'CreateEtaAlertForRouteStop' => '\\StructType\\CreateEtaAlertForRouteStop',
            'StopEtaAlert' => '\\StructType\\StopEtaAlert',
            'CreateEtaAlertForRouteStopResponse' => '\\StructType\\CreateEtaAlertForRouteStopResponse',
            'CreateTemperatureAlertForVehicle' => '\\StructType\\CreateTemperatureAlertForVehicle',
            'TemperatureAlert' => '\\StructType\\TemperatureAlert',
            'CreateTemperatureAlertForVehicleResponse' => '\\StructType\\CreateTemperatureAlertForVehicleResponse',
            'DeActivateTemperatureAlertForVehicle' => '\\StructType\\DeActivateTemperatureAlertForVehicle',
            'DeActivateTemperatureAlertForVehicleResponse' => '\\StructType\\DeActivateTemperatureAlertForVehicleResponse',
        );
    }
}
