<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createRoute StructType
 * @subpackage Structs
 */
class CreateRoute extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The newCollection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Collection
     */
    public $newCollection;
    /**
     * Constructor method for createRoute
     * @uses CreateRoute::setLogin()
     * @uses CreateRoute::setPassword()
     * @uses CreateRoute::setNewCollection()
     * @param string $login
     * @param string $password
     * @param \StructType\Collection $newCollection
     */
    public function __construct($login = null, $password = null, \StructType\Collection $newCollection = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setNewCollection($newCollection);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\CreateRoute
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\CreateRoute
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get newCollection value
     * @return \StructType\Collection|null
     */
    public function getNewCollection()
    {
        return $this->newCollection;
    }
    /**
     * Set newCollection value
     * @param \StructType\Collection $newCollection
     * @return \StructType\CreateRoute
     */
    public function setNewCollection(\StructType\Collection $newCollection = null)
    {
        $this->newCollection = $newCollection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateRoute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
