<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateTemperatureAlertForVehicle StructType
 * @subpackage Structs
 */
class CreateTemperatureAlertForVehicle extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The vehicleRegistration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $vehicleRegistration;
    /**
     * The alert
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TemperatureAlert
     */
    public $alert;
    /**
     * Constructor method for CreateTemperatureAlertForVehicle
     * @uses CreateTemperatureAlertForVehicle::setLogin()
     * @uses CreateTemperatureAlertForVehicle::setPassword()
     * @uses CreateTemperatureAlertForVehicle::setVehicleRegistration()
     * @uses CreateTemperatureAlertForVehicle::setAlert()
     * @param string $login
     * @param string $password
     * @param string $vehicleRegistration
     * @param \StructType\TemperatureAlert $alert
     */
    public function __construct($login = null, $password = null, $vehicleRegistration = null, \StructType\TemperatureAlert $alert = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setVehicleRegistration($vehicleRegistration)
            ->setAlert($alert);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\CreateTemperatureAlertForVehicle
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\CreateTemperatureAlertForVehicle
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get vehicleRegistration value
     * @return string|null
     */
    public function getVehicleRegistration()
    {
        return $this->vehicleRegistration;
    }
    /**
     * Set vehicleRegistration value
     * @param string $vehicleRegistration
     * @return \StructType\CreateTemperatureAlertForVehicle
     */
    public function setVehicleRegistration($vehicleRegistration = null)
    {
        // validation for constraint: string
        if (!is_null($vehicleRegistration) && !is_string($vehicleRegistration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vehicleRegistration)), __LINE__);
        }
        $this->vehicleRegistration = $vehicleRegistration;
        return $this;
    }
    /**
     * Get alert value
     * @return \StructType\TemperatureAlert|null
     */
    public function getAlert()
    {
        return $this->alert;
    }
    /**
     * Set alert value
     * @param \StructType\TemperatureAlert $alert
     * @return \StructType\CreateTemperatureAlertForVehicle
     */
    public function setAlert(\StructType\TemperatureAlert $alert = null)
    {
        $this->alert = $alert;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateTemperatureAlertForVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
