<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getJobCollectionV2 StructType
 * @subpackage Structs
 */
class GetJobCollectionV2 extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The searchcriteria
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SearchCriteria
     */
    public $searchcriteria;
    /**
     * Constructor method for getJobCollectionV2
     * @uses GetJobCollectionV2::setLogin()
     * @uses GetJobCollectionV2::setPassword()
     * @uses GetJobCollectionV2::setSearchcriteria()
     * @param string $login
     * @param string $password
     * @param \StructType\SearchCriteria $searchcriteria
     */
    public function __construct($login = null, $password = null, \StructType\SearchCriteria $searchcriteria = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setSearchcriteria($searchcriteria);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\GetJobCollectionV2
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\GetJobCollectionV2
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get searchcriteria value
     * @return \StructType\SearchCriteria|null
     */
    public function getSearchcriteria()
    {
        return $this->searchcriteria;
    }
    /**
     * Set searchcriteria value
     * @param \StructType\SearchCriteria $searchcriteria
     * @return \StructType\GetJobCollectionV2
     */
    public function setSearchcriteria(\StructType\SearchCriteria $searchcriteria = null)
    {
        $this->searchcriteria = $searchcriteria;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetJobCollectionV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
