<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LoadVehicleChecks StructType
 * @subpackage Structs
 */
class LoadVehicleChecks extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The check
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\VehicleCheck
     */
    public $check;
    /**
     * Constructor method for LoadVehicleChecks
     * @uses LoadVehicleChecks::setLogin()
     * @uses LoadVehicleChecks::setPassword()
     * @uses LoadVehicleChecks::setCheck()
     * @param string $login
     * @param string $password
     * @param \StructType\VehicleCheck $check
     */
    public function __construct($login = null, $password = null, \StructType\VehicleCheck $check = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setCheck($check);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\LoadVehicleChecks
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\LoadVehicleChecks
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get check value
     * @return \StructType\VehicleCheck|null
     */
    public function getCheck()
    {
        return $this->check;
    }
    /**
     * Set check value
     * @param \StructType\VehicleCheck $check
     * @return \StructType\LoadVehicleChecks
     */
    public function setCheck(\StructType\VehicleCheck $check = null)
    {
        $this->check = $check;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LoadVehicleChecks
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
