<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchCriteria StructType
 * @subpackage Structs
 */
class SearchCriteria extends AbstractStructBase
{
    /**
     * The estimatedArrivalTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $estimatedArrivalTime;
    /**
     * The estimatedDeparturetime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $estimatedDeparturetime;
    /**
     * The actualArrivalTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $actualArrivalTime;
    /**
     * The actualdepartureTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $actualdepartureTime;
    /**
     * The collectionID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $collectionID;
    /**
     * The driverReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $driverReference;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfStatusOptions
     */
    public $status;
    /**
     * The stopReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $stopReference;
    /**
     * Constructor method for searchCriteria
     * @uses SearchCriteria::setEstimatedArrivalTime()
     * @uses SearchCriteria::setEstimatedDeparturetime()
     * @uses SearchCriteria::setActualArrivalTime()
     * @uses SearchCriteria::setActualdepartureTime()
     * @uses SearchCriteria::setCollectionID()
     * @uses SearchCriteria::setDriverReference()
     * @uses SearchCriteria::setStatus()
     * @uses SearchCriteria::setStopReference()
     * @param string $estimatedArrivalTime
     * @param string $estimatedDeparturetime
     * @param string $actualArrivalTime
     * @param string $actualdepartureTime
     * @param \ArrayType\ArrayOfString $collectionID
     * @param \ArrayType\ArrayOfString $driverReference
     * @param \ArrayType\ArrayOfStatusOptions $status
     * @param \ArrayType\ArrayOfString $stopReference
     */
    public function __construct($estimatedArrivalTime = null, $estimatedDeparturetime = null, $actualArrivalTime = null, $actualdepartureTime = null, \ArrayType\ArrayOfString $collectionID = null, \ArrayType\ArrayOfString $driverReference = null, \ArrayType\ArrayOfStatusOptions $status = null, \ArrayType\ArrayOfString $stopReference = null)
    {
        $this
            ->setEstimatedArrivalTime($estimatedArrivalTime)
            ->setEstimatedDeparturetime($estimatedDeparturetime)
            ->setActualArrivalTime($actualArrivalTime)
            ->setActualdepartureTime($actualdepartureTime)
            ->setCollectionID($collectionID)
            ->setDriverReference($driverReference)
            ->setStatus($status)
            ->setStopReference($stopReference);
    }
    /**
     * Get estimatedArrivalTime value
     * @return string
     */
    public function getEstimatedArrivalTime()
    {
        return $this->estimatedArrivalTime;
    }
    /**
     * Set estimatedArrivalTime value
     * @param string $estimatedArrivalTime
     * @return \StructType\SearchCriteria
     */
    public function setEstimatedArrivalTime($estimatedArrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedArrivalTime) && !is_string($estimatedArrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($estimatedArrivalTime)), __LINE__);
        }
        $this->estimatedArrivalTime = $estimatedArrivalTime;
        return $this;
    }
    /**
     * Get estimatedDeparturetime value
     * @return string
     */
    public function getEstimatedDeparturetime()
    {
        return $this->estimatedDeparturetime;
    }
    /**
     * Set estimatedDeparturetime value
     * @param string $estimatedDeparturetime
     * @return \StructType\SearchCriteria
     */
    public function setEstimatedDeparturetime($estimatedDeparturetime = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedDeparturetime) && !is_string($estimatedDeparturetime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($estimatedDeparturetime)), __LINE__);
        }
        $this->estimatedDeparturetime = $estimatedDeparturetime;
        return $this;
    }
    /**
     * Get actualArrivalTime value
     * @return string
     */
    public function getActualArrivalTime()
    {
        return $this->actualArrivalTime;
    }
    /**
     * Set actualArrivalTime value
     * @param string $actualArrivalTime
     * @return \StructType\SearchCriteria
     */
    public function setActualArrivalTime($actualArrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($actualArrivalTime) && !is_string($actualArrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($actualArrivalTime)), __LINE__);
        }
        $this->actualArrivalTime = $actualArrivalTime;
        return $this;
    }
    /**
     * Get actualdepartureTime value
     * @return string
     */
    public function getActualdepartureTime()
    {
        return $this->actualdepartureTime;
    }
    /**
     * Set actualdepartureTime value
     * @param string $actualdepartureTime
     * @return \StructType\SearchCriteria
     */
    public function setActualdepartureTime($actualdepartureTime = null)
    {
        // validation for constraint: string
        if (!is_null($actualdepartureTime) && !is_string($actualdepartureTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($actualdepartureTime)), __LINE__);
        }
        $this->actualdepartureTime = $actualdepartureTime;
        return $this;
    }
    /**
     * Get collectionID value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCollectionID()
    {
        return $this->collectionID;
    }
    /**
     * Set collectionID value
     * @param \ArrayType\ArrayOfString $collectionID
     * @return \StructType\SearchCriteria
     */
    public function setCollectionID(\ArrayType\ArrayOfString $collectionID = null)
    {
        $this->collectionID = $collectionID;
        return $this;
    }
    /**
     * Get driverReference value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getDriverReference()
    {
        return $this->driverReference;
    }
    /**
     * Set driverReference value
     * @param \ArrayType\ArrayOfString $driverReference
     * @return \StructType\SearchCriteria
     */
    public function setDriverReference(\ArrayType\ArrayOfString $driverReference = null)
    {
        $this->driverReference = $driverReference;
        return $this;
    }
    /**
     * Get status value
     * @return \ArrayType\ArrayOfStatusOptions|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \ArrayType\ArrayOfStatusOptions $status
     * @return \StructType\SearchCriteria
     */
    public function setStatus(\ArrayType\ArrayOfStatusOptions $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Get stopReference value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getStopReference()
    {
        return $this->stopReference;
    }
    /**
     * Set stopReference value
     * @param \ArrayType\ArrayOfString $stopReference
     * @return \StructType\SearchCriteria
     */
    public function setStopReference(\ArrayType\ArrayOfString $stopReference = null)
    {
        $this->stopReference = $stopReference;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SearchCriteria
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
