<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetVehicleNextServiceInformation StructType
 * @subpackage Structs
 */
class SetVehicleNextServiceInformation extends AbstractStructBase
{
    /**
     * The unit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $unit;
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The serviceInformationCollection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfNextServiceInformation
     */
    public $serviceInformationCollection;
    /**
     * Constructor method for SetVehicleNextServiceInformation
     * @uses SetVehicleNextServiceInformation::setUnit()
     * @uses SetVehicleNextServiceInformation::setLogin()
     * @uses SetVehicleNextServiceInformation::setPassword()
     * @uses SetVehicleNextServiceInformation::setServiceInformationCollection()
     * @param string $unit
     * @param string $login
     * @param string $password
     * @param \ArrayType\ArrayOfNextServiceInformation $serviceInformationCollection
     */
    public function __construct($unit = null, $login = null, $password = null, \ArrayType\ArrayOfNextServiceInformation $serviceInformationCollection = null)
    {
        $this
            ->setUnit($unit)
            ->setLogin($login)
            ->setPassword($password)
            ->setServiceInformationCollection($serviceInformationCollection);
    }
    /**
     * Get unit value
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @uses \EnumType\DistanceUnit::valueIsValid()
     * @uses \EnumType\DistanceUnit::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $unit
     * @return \StructType\SetVehicleNextServiceInformation
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DistanceUnit::valueIsValid($unit)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $unit, implode(', ', \EnumType\DistanceUnit::getValidValues())), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\SetVehicleNextServiceInformation
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\SetVehicleNextServiceInformation
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get serviceInformationCollection value
     * @return \ArrayType\ArrayOfNextServiceInformation|null
     */
    public function getServiceInformationCollection()
    {
        return $this->serviceInformationCollection;
    }
    /**
     * Set serviceInformationCollection value
     * @param \ArrayType\ArrayOfNextServiceInformation $serviceInformationCollection
     * @return \StructType\SetVehicleNextServiceInformation
     */
    public function setServiceInformationCollection(\ArrayType\ArrayOfNextServiceInformation $serviceInformationCollection = null)
    {
        $this->serviceInformationCollection = $serviceInformationCollection;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetVehicleNextServiceInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
