<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeliveryCompletionDetails StructType
 * @subpackage Structs
 */
class UpdateDeliveryCompletionDetails extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The stopReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $stopReference;
    /**
     * The signature
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $signature;
    /**
     * The printName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $printName;
    /**
     * The feedback
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $feedback;
    /**
     * Constructor method for UpdateDeliveryCompletionDetails
     * @uses UpdateDeliveryCompletionDetails::setLogin()
     * @uses UpdateDeliveryCompletionDetails::setPassword()
     * @uses UpdateDeliveryCompletionDetails::setStopReference()
     * @uses UpdateDeliveryCompletionDetails::setSignature()
     * @uses UpdateDeliveryCompletionDetails::setPrintName()
     * @uses UpdateDeliveryCompletionDetails::setFeedback()
     * @param string $login
     * @param string $password
     * @param string $stopReference
     * @param string $signature
     * @param string $printName
     * @param string $feedback
     */
    public function __construct($login = null, $password = null, $stopReference = null, $signature = null, $printName = null, $feedback = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setStopReference($stopReference)
            ->setSignature($signature)
            ->setPrintName($printName)
            ->setFeedback($feedback);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get stopReference value
     * @return string|null
     */
    public function getStopReference()
    {
        return $this->stopReference;
    }
    /**
     * Set stopReference value
     * @param string $stopReference
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setStopReference($stopReference = null)
    {
        // validation for constraint: string
        if (!is_null($stopReference) && !is_string($stopReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stopReference)), __LINE__);
        }
        $this->stopReference = $stopReference;
        return $this;
    }
    /**
     * Get signature value
     * @return string|null
     */
    public function getSignature()
    {
        return $this->signature;
    }
    /**
     * Set signature value
     * @param string $signature
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setSignature($signature = null)
    {
        // validation for constraint: string
        if (!is_null($signature) && !is_string($signature)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($signature)), __LINE__);
        }
        $this->signature = $signature;
        return $this;
    }
    /**
     * Get printName value
     * @return string|null
     */
    public function getPrintName()
    {
        return $this->printName;
    }
    /**
     * Set printName value
     * @param string $printName
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setPrintName($printName = null)
    {
        // validation for constraint: string
        if (!is_null($printName) && !is_string($printName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($printName)), __LINE__);
        }
        $this->printName = $printName;
        return $this;
    }
    /**
     * Get feedback value
     * @return string|null
     */
    public function getFeedback()
    {
        return $this->feedback;
    }
    /**
     * Set feedback value
     * @param string $feedback
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public function setFeedback($feedback = null)
    {
        // validation for constraint: string
        if (!is_null($feedback) && !is_string($feedback)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($feedback)), __LINE__);
        }
        $this->feedback = $feedback;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateDeliveryCompletionDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
