<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeliveryCompletionDetailsV2 StructType
 * @subpackage Structs
 */
class UpdateDeliveryCompletionDetailsV2 extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The stopReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $stopReference;
    /**
     * The details
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\StopCompletionDetails
     */
    public $details;
    /**
     * Constructor method for UpdateDeliveryCompletionDetailsV2
     * @uses UpdateDeliveryCompletionDetailsV2::setLogin()
     * @uses UpdateDeliveryCompletionDetailsV2::setPassword()
     * @uses UpdateDeliveryCompletionDetailsV2::setStopReference()
     * @uses UpdateDeliveryCompletionDetailsV2::setDetails()
     * @param string $login
     * @param string $password
     * @param string $stopReference
     * @param \StructType\StopCompletionDetails $details
     */
    public function __construct($login = null, $password = null, $stopReference = null, \StructType\StopCompletionDetails $details = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setStopReference($stopReference)
            ->setDetails($details);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\UpdateDeliveryCompletionDetailsV2
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateDeliveryCompletionDetailsV2
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get stopReference value
     * @return string|null
     */
    public function getStopReference()
    {
        return $this->stopReference;
    }
    /**
     * Set stopReference value
     * @param string $stopReference
     * @return \StructType\UpdateDeliveryCompletionDetailsV2
     */
    public function setStopReference($stopReference = null)
    {
        // validation for constraint: string
        if (!is_null($stopReference) && !is_string($stopReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stopReference)), __LINE__);
        }
        $this->stopReference = $stopReference;
        return $this;
    }
    /**
     * Get details value
     * @return \StructType\StopCompletionDetails|null
     */
    public function getDetails()
    {
        return $this->details;
    }
    /**
     * Set details value
     * @param \StructType\StopCompletionDetails $details
     * @return \StructType\UpdateDeliveryCompletionDetailsV2
     */
    public function setDetails(\StructType\StopCompletionDetails $details = null)
    {
        $this->details = $details;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateDeliveryCompletionDetailsV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
