<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeliveryEnd StructType
 * @subpackage Structs
 */
class UpdateDeliveryEnd extends AbstractStructBase
{
    /**
     * The endTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $endTime;
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The stopReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $stopReference;
    /**
     * Constructor method for UpdateDeliveryEnd
     * @uses UpdateDeliveryEnd::setEndTime()
     * @uses UpdateDeliveryEnd::setLogin()
     * @uses UpdateDeliveryEnd::setPassword()
     * @uses UpdateDeliveryEnd::setStopReference()
     * @param string $endTime
     * @param string $login
     * @param string $password
     * @param string $stopReference
     */
    public function __construct($endTime = null, $login = null, $password = null, $stopReference = null)
    {
        $this
            ->setEndTime($endTime)
            ->setLogin($login)
            ->setPassword($password)
            ->setStopReference($stopReference);
    }
    /**
     * Get endTime value
     * @return string
     */
    public function getEndTime()
    {
        return $this->endTime;
    }
    /**
     * Set endTime value
     * @param string $endTime
     * @return \StructType\UpdateDeliveryEnd
     */
    public function setEndTime($endTime = null)
    {
        // validation for constraint: string
        if (!is_null($endTime) && !is_string($endTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endTime)), __LINE__);
        }
        $this->endTime = $endTime;
        return $this;
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\UpdateDeliveryEnd
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateDeliveryEnd
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get stopReference value
     * @return string|null
     */
    public function getStopReference()
    {
        return $this->stopReference;
    }
    /**
     * Set stopReference value
     * @param string $stopReference
     * @return \StructType\UpdateDeliveryEnd
     */
    public function setStopReference($stopReference = null)
    {
        // validation for constraint: string
        if (!is_null($stopReference) && !is_string($stopReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stopReference)), __LINE__);
        }
        $this->stopReference = $stopReference;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateDeliveryEnd
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
