<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeliveryLineItemQuantities StructType
 * @subpackage Structs
 */
class UpdateDeliveryLineItemQuantities extends AbstractStructBase
{
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The lineItemUpdates
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDeliveryLineItemUpdate
     */
    public $lineItemUpdates;
    /**
     * Constructor method for UpdateDeliveryLineItemQuantities
     * @uses UpdateDeliveryLineItemQuantities::setLogin()
     * @uses UpdateDeliveryLineItemQuantities::setPassword()
     * @uses UpdateDeliveryLineItemQuantities::setLineItemUpdates()
     * @param string $login
     * @param string $password
     * @param \ArrayType\ArrayOfDeliveryLineItemUpdate $lineItemUpdates
     */
    public function __construct($login = null, $password = null, \ArrayType\ArrayOfDeliveryLineItemUpdate $lineItemUpdates = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setLineItemUpdates($lineItemUpdates);
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\UpdateDeliveryLineItemQuantities
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateDeliveryLineItemQuantities
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get lineItemUpdates value
     * @return \ArrayType\ArrayOfDeliveryLineItemUpdate|null
     */
    public function getLineItemUpdates()
    {
        return $this->lineItemUpdates;
    }
    /**
     * Set lineItemUpdates value
     * @param \ArrayType\ArrayOfDeliveryLineItemUpdate $lineItemUpdates
     * @return \StructType\UpdateDeliveryLineItemQuantities
     */
    public function setLineItemUpdates(\ArrayType\ArrayOfDeliveryLineItemUpdate $lineItemUpdates = null)
    {
        $this->lineItemUpdates = $lineItemUpdates;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateDeliveryLineItemQuantities
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
