<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeliveryStart StructType
 * @subpackage Structs
 */
class UpdateDeliveryStart extends AbstractStructBase
{
    /**
     * The startTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $startTime;
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The stopReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $stopReference;
    /**
     * Constructor method for UpdateDeliveryStart
     * @uses UpdateDeliveryStart::setStartTime()
     * @uses UpdateDeliveryStart::setLogin()
     * @uses UpdateDeliveryStart::setPassword()
     * @uses UpdateDeliveryStart::setStopReference()
     * @param string $startTime
     * @param string $login
     * @param string $password
     * @param string $stopReference
     */
    public function __construct($startTime = null, $login = null, $password = null, $stopReference = null)
    {
        $this
            ->setStartTime($startTime)
            ->setLogin($login)
            ->setPassword($password)
            ->setStopReference($stopReference);
    }
    /**
     * Get startTime value
     * @return string
     */
    public function getStartTime()
    {
        return $this->startTime;
    }
    /**
     * Set startTime value
     * @param string $startTime
     * @return \StructType\UpdateDeliveryStart
     */
    public function setStartTime($startTime = null)
    {
        // validation for constraint: string
        if (!is_null($startTime) && !is_string($startTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startTime)), __LINE__);
        }
        $this->startTime = $startTime;
        return $this;
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\UpdateDeliveryStart
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateDeliveryStart
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get stopReference value
     * @return string|null
     */
    public function getStopReference()
    {
        return $this->stopReference;
    }
    /**
     * Set stopReference value
     * @param string $stopReference
     * @return \StructType\UpdateDeliveryStart
     */
    public function setStopReference($stopReference = null)
    {
        // validation for constraint: string
        if (!is_null($stopReference) && !is_string($stopReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stopReference)), __LINE__);
        }
        $this->stopReference = $stopReference;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateDeliveryStart
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
